/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using UnityEngine.Rendering;using System.Collections.Generic;using MeshVR;using MeshedVR;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using System.Linq;using MVR.FileManagementSecure;using System.Collections;using System;using Random = UnityEngine.Random;using UnityEngine.UI;using System.Security.Cryptography;using System.Text;namespace PluginIdea.SlideControl{public struct SizeMode{public const int Custom = 0;public const int AutoSize = 1;public const int Lock = 2;}public class SlideControl : MVRScript{private const string DefaultImagePath = "Custom/Assets/Images";public const string InputModule = "InputModule";public const string VideoPlayerModule = "VideoPlayerModule";private const string bgShaderName = "PluginIdea/Slide_bgPlane";private TextureSettings slideTextureSetting = new TextureSettings(){compress = true, linearColor = false};private List<string> playModes = new List<string>{"Random", "Sequence", "Sequence Inverse"};private List<string> planeShapes = new List<string>{"Square", "Circular"};private List<string> playTypes = new List<string>{"ImagesPlay", "VideoPlay"};private List<string> transitionTypes = new List<string>{"Slide_Shutter5", "Slide_Shutter1", "Slide_Shutter2", "Slide_Shutter3", "Slide_Shutter4",            "Slide_Split2", "Slide_Split3", "Slide_Split4", "Slide_Split5", "Slide_Yuan","Slide_Dissolve1","Slide_Dissolve2","Slide_Dissolve3"};private List<string> aspectRadioPresets = new List<string>{"Custom","Auto","16:9", "16:10", "4:3", "2:1", "1:1"};private Dictionary<string, int> dic_EaseType = new Dictionary<string, int>{{"easeInQuad", iTween.EaseType.easeInQuad},{"easeOutQuad", iTween.EaseType.easeOutQuad},{"easeInOutQuad", iTween.EaseType.easeInOutQuad},{"easeInCubic", iTween.EaseType.easeInCubic},{"easeOutCubic", iTween.EaseType.easeOutCubic},{"easeInOutCubic", iTween.EaseType.easeInOutCubic},{"easeInQuart", iTween.EaseType.easeInQuart},{"easeOutQuart", iTween.EaseType.easeOutQuart},{"easeInOutQuart", iTween.EaseType.easeInOutQuart},{"easeInQuint", iTween.EaseType.easeInQuint},{"easeOutQuint", iTween.EaseType.easeOutQuint},{"easeInOutQuint", iTween.EaseType.easeInOutQuint},{"easeInSine", iTween.EaseType.easeInSine},{"easeOutSine", iTween.EaseType.easeOutSine},{"easeInOutSine", iTween.EaseType.easeInOutSine},{"easeInExpo", iTween.EaseType.easeInExpo},{"easeOutExpo", iTween.EaseType.easeOutExpo},{"easeInOutExpo", iTween.EaseType.easeInOutExpo},{"easeInCirc", iTween.EaseType.easeInCirc},{"easeOutCirc", iTween.EaseType.easeOutCirc},{"easeInOutCirc", iTween.EaseType.easeInOutCirc},{"linear", iTween.EaseType.linear},{"spring", iTween.EaseType.spring},{"easeInBounce", iTween.EaseType.easeInBounce},{"easeOutBounce", iTween.EaseType.easeOutBounce},{"easeInOutBounce", iTween.EaseType.easeInOutBounce},{"easeInBack", iTween.EaseType.easeInBack},{"easeOutBack", iTween.EaseType.easeOutBack},{"easeInOutBack", iTween.EaseType.easeInOutBack},{"easeInElastic", iTween.EaseType.easeInElastic},{"easeOutElastic", iTween.EaseType.easeOutElastic},{"easeInOutElastic", iTween.EaseType.easeInOutElastic},};private List<string> imageList = new List<string>();private List<Texture2D> cachedImages = new List<Texture2D>();private List<int> randomPool = new List<int>();private JSONStorableStringChooser playModeChooser;private JSONStorableStringChooser aspectRadioPresetChooser;private JSONStorableStringChooser transitionAnimChooser;private JSONStorableStringChooser transitionTypeChooser;private JSONStorableStringChooser planeShapeChooser;private JSONStorableStringChooser playTypeChooser;private JSONStorableFloat uvWrapCount;private JSONStorableFloat uvCutoff;private JSONStorableBool isAutoPlay;private JSONStorableBool isAutoSize;private JSONStorableBool isRandomTransitionType;private JSONStorableFloat switchingInterval;private JSONStorableUrl folderPath;private JSONStorableFloat width, height;private JSONStorableFloat translateDuration;private JSONStorableFloat preloadAmount;private JSONStorableBool islockWhRadio;private JSONStorableBool isBGCastShadow;private JSONStorableColor colorPicker;private JSONStorableString playMode;private List<object> circularPlaneUIList = new List<object>();private List<object> quadPlaneUIList = new List<object>();public JSONStorableAction nextImgAction;public JSONStorableAction prevImgAction;private JSONStorableFloat amount;private Dictionary<string, SlideModuleBase> uid2Modules = new Dictionary<string, SlideModuleBase>();private Dictionary<string, Shader> dic_BundleShaders = new Dictionary<string, Shader>();private float timer;private bool isExternalResourcesLoaded;private float whAspectValue = 1;private float tmpWhAspectValue = 1;private int currentSizeMode = SizeMode.Custom;private string lastTransitionType;private string currentFolderUrl;private Request request;private const string Key_Active = "cer";private JSONStorableString aci;private string info;private Material bgMat;private Material fgMat;private float Aspect{get{return currentSizeMode == SizeMode.AutoSize ? tmpWhAspectValue : whAspectValue;}}public bool IsOnImagePlayType{get{return playTypeChooser.val == "ImagesPlay";}}public bool IsOnVideoPlayType{get{return playTypeChooser.val == "VideoPlay";}}private SlideModuleBase GetModuleWithName(string moduleName){return uid2Modules[moduleName];}public bool IsInitied{get{return isExternalResourcesLoaded;}}public Dictionary<string, Shader> Dic_BundleShaders{get{return this.dic_BundleShaders;}}private GameObject bgPlane;private GameObject rdPlane;private Renderer rd, bgRd;public override void Init(){base.Init();Location.InitTData();if (containingAtom.type != "Empty"){SuperController.LogError(Location.GetStr(Location.NeedEmptyPlugin));return;}ResourceInit();DataInit();UIInit();EventInit();LogicInit();}private void ResourceInit(){string assetsBundlePath = Utils.GetPluginPath(this) + "/resources/slidecontrol.assetbundle";Request request = new Request{path = assetsBundlePath, callback = OnAssetBundleLoaded};AssetLoader.QueueLoadAssetBundleFromFile(request);}private void OnAssetBundleLoaded(Request request){this.request = request;Shader[] shaders = request.assetBundle.LoadAllAssets<Shader>();for (int i = 0;i < shaders.Length;i++){if (!dic_BundleShaders.ContainsKey(shaders[i].name)){string key = shaders[i].name;dic_BundleShaders.Add(key, shaders[i]);}}isExternalResourcesLoaded = true;planeShapeChooser.setCallbackFunction(planeShapeChooser.val);aspectRadioPresetChooser.setCallbackFunction(aspectRadioPresetChooser.val);foreach (var module in uid2Modules.Values.ToList()){module.DelayInit();}}private void DataInit(){bgMat = new Material(Shader.Find("Standard"));fgMat = new Material(Shader.Find("Standard"));}private GameObject loadingIcon;public bool bcs;private void UIInit(){loadingIcon = SuperController.singleton.loadingIcon.Find("LoadingIconCanvas/LoadingIcon").gameObject;loadingIcon.SetActive(false);Utils.InitUI(CreateUIElement);aci = new JSONStorableString("ac", Location.GetText(Location.GetStr(Location.ACInfo)));bcs = false;string cerFolder = "Saves/PluginData/PluginIdea/Common/";string cerPath = cerFolder + Key_Active;FileManagerSecure.CreateDirectory(cerFolder);if (FileManagerSecure.FileExists(cerPath)){info = FileManagerSecure.ReadAllText(cerPath);if (bs(info)){aci.val = info;bcs = true;}}if (!bcs){JSONStorableString storable = new JSONStorableString("sto", GMAA());Utils.SetupTextInput(this, Location.GetStr(Location.InfoStr), storable, false).GetComponent<LayoutElement>().minWidth = 500;Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.ACTIP2), 300, false);Utils.CreateButton(this, Location.GetStr(Location.GetK), () =>{string url = Location.IsChinease ? @"https:\/\/afdian.net/p/f68809c06fc111ed9a1752540025c377" : @"https:\/\/www.patreon.com/posts/creator-edition-75248400?utm_medium=clipboard_copy&utm_source=copyLink&utm_campaign=postshare_creator&utm_content=join_link";UnityEngine.Application.OpenURL(url);}, false, true).textColor = Color.red;Utils.SetupTextInput(this, Location.GetStr(Location.AcStr), aci, false).GetComponent<LayoutElement>().minWidth = 700;Utils.CreateButton(this, Location.GetStr(Location.AcBtn), () =>{string s = GMAAP();string pd = MDPWd(Location.r("_moc") + s);if (pd == aci.val.Trim().Substring(8)){SuperController.LogMessage(Location.GetText(Location.GetStr(Location.AcSuc)));FileManagerSecure.WriteAllText(cerPath, pd);}else{SuperController.LogMessage(Location.GetText(Location.GetStr(Location.InAc)));}}, false, true).textColor = Color.red;Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.ACTIP), 120, false).text.color = Color.red;Utils.CreateSpacer(this, 30, false);}var aff = bcs;if (!aff) Utils.CreateSpacer(this,730, true);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.PluginInfo)                 , 200, true);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.CommonParaSubtitle), 40, false);playModeChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.PlaybackOrder), playModes, 1, false, true);playTypeChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.PlayTypes), playTypes, 0, false, true);playTypeChooser.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;if (val == "ImagesPlay"){VideoPlayerModule vpModule = GetModuleWithName(VideoPlayerModule) as VideoPlayerModule;vpModule.Reset();}else if (val == "VideoPlay"){Reset();}};planeShapeChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.PlaneType), planeShapes,1, false, true);planeShapeChooser.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;if (rdPlane != null) Destroy(rdPlane);if (val == "Square"){CreateQuadObject();bgRd.material.shader = dic_BundleShaders["PluginIdea/Slide_bgPlane"];uvWrapCount.val = uvWrapCount.defaultVal;uvCutoff.val = uvCutoff.defaultVal;}else if (val == "Circular"){CreateCircularObject();bgRd.material.shader = dic_BundleShaders["PluginIdea/Slide_bgPlane"];StartCoroutine(DelayParaSet(()=>{bgRd.material.SetFloat("_UVWrapCount", uvWrapCount.val);rd.material.SetFloat("_UVWrapCount", uvWrapCount.val);bgRd.material.SetFloat("_UVCutOff", uvCutoff.val);rd.material.SetFloat("_UVCutOff", uvCutoff.val);},0.2f));}colorPicker.setCallbackFunction(colorPicker.val.H, colorPicker.val.S, colorPicker.val.V);rd.material.SetFloat("_Width", amount.val);bgRd.shadowCastingMode = isBGCastShadow.val ? ShadowCastingMode.TwoSided : ShadowCastingMode.Off;rd.shadowCastingMode = ShadowCastingMode.Off;width.setCallbackFunction(width.val);transitionTypeChooser.setCallbackFunction(transitionTypeChooser.val);if (!string.IsNullOrEmpty(folderPath.val)){folderPath.Reload();}};Utils.CreateSpacer(this, 20, false);aspectRadioPresetChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.AspectRadios), aspectRadioPresets, 0, false, true);aspectRadioPresetChooser.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;switch (val){case "Custom": whAspectValue = width.val / height.val;currentSizeMode = SizeMode.Custom;Utils.ActiveSliderUI(width.slider, true);Utils.ActiveSliderUI(height.slider, true);break;case "Auto": tmpWhAspectValue = 1;currentSizeMode = SizeMode.AutoSize;Utils.ActiveSliderUI(width.slider, true);Utils.ActiveSliderUI(height.slider, false);break;case "16:9": whAspectValue = 1.777f;break;case "16:10": whAspectValue = 1.6f;break;case "4:3": whAspectValue = 1.333f;break;case "2:1": whAspectValue = 2f;break;case "1:1": whAspectValue = 1f;break;}if (val != "Custom" && val != "Auto"){currentSizeMode = SizeMode.Lock;Utils.ActiveSliderUI(width.slider, true);Utils.ActiveSliderUI(height.slider, false);CaculateSizeFromWidth(width.val);}};isBGCastShadow = Utils.CreateToggle(this, Location.GetStr(Location.IsCastShadow), true, false, true);isBGCastShadow.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;bgRd.shadowCastingMode = val ? ShadowCastingMode.TwoSided : ShadowCastingMode.Off;rd.shadowCastingMode = ShadowCastingMode.Off;};Utils.CreateSpacer(this, 20, false);width = Utils.CreateSliderFloat(this, Location.GetStr(Location.WidthRadius), 1.6f, 0.1f, 20f, false, true);this.width.setCallbackFunction = (width) =>{if (!isExternalResourcesLoaded) return;CaculateSizeFromWidth(width);};height = Utils.CreateSliderFloat(this, Location.GetStr(Location.Height), 1f, 0.1f, 20f, false, true);height.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;if (planeShapeChooser.val == "Circular"){rdPlane.transform.localScale = new Vector3(rdPlane.transform.localScale.x, val, rdPlane.transform.localScale.x);}else{rdPlane.transform.localScale = new Vector3(rdPlane.transform.localScale.x, val, 1);}};var titleText = Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.CircularPlaneSubtitle), 35, false);uvWrapCount = Utils.CreateSliderFloat(this, Location.GetStr(Location.UVWrapCount), 4.5f, 0.5f, 15, false, true);uvWrapCount.setCallbackFunction = (wrap) =>{if (!isExternalResourcesLoaded) return;bgRd.material.SetFloat("_UVWrapCount", wrap);rd.material.SetFloat("_UVWrapCount", wrap);rdPlane.transform.localRotation = Quaternion.Euler(0, 180 - (360f / wrap) * 0.5f, 0);};uvCutoff = Utils.CreateSliderFloat(this, Location.GetStr(Location.UVCutOff), 1, 0f, 10, false, true);uvCutoff.setCallbackFunction = (wrap) =>{if (!isExternalResourcesLoaded) return;bgRd.material.SetFloat("_UVCutOff", wrap);rd.material.SetFloat("_UVCutOff", wrap);};colorPicker = Utils.CreateColor(this, Location.GetStr(Location.MainColor), Color.white, false);colorPicker.setCallbackFunction = (h, s, v) =>{if (!isExternalResourcesLoaded) return;Color col = Color.HSVToRGB(h, s, v);rd.material.SetColor("_Color", col);bgRd.material.SetColor("_Color", col);};Utils.CreateSpacer(this, 30, true);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.ImagePlaySubtitle), 40, true);isAutoPlay = Utils.CreateToggle(this, Location.GetStr(Location.IsAutoPlay), true, true, true);Utils.CreateTwinButton(this, Location.GetStr(Location.PrevImage), () =>{prevImgAction.actionCallback();}, Location.GetStr(Location.NextImage), () =>{nextImgAction.actionCallback();}, true, true);folderPath = Utils.CreateFileChooser(this, Location.GetStr(Location.SetFolder), DefaultImagePath, true, null, true);folderPath.setCallbackFunction = (url) =>{string folder = Utils.GetFolderFromUrl(url);string filename = FileManagerSecure.GetFileName(url);if (!IsOnImagePlayType) return;if (!isExternalResourcesLoaded) return;imgIndex = 0;currentFolderUrl = folder;List<string> files = new List<string>();Utils.GetAllSubFiles(folder, ref files);if (files.Count > 0){if (currentTex != null) Destroy(currentTex);if (nextTex != null) Destroy(nextTex);imageList.Clear();files.ForEach(p =>{if (p.EndsWith(".jpg") || p.EndsWith(".png") || p.EndsWith(".jpeg") || p.EndsWith(".tiff")){imageList.Add(p);}});if (imageList.Count <= 1){SuperController.LogError("The folder needs to contain at least two valid pictures!");return;}string pathSelect = imageList.FirstOrDefault(x => x.EndsWith(filename));imgIndex = imageList.IndexOf(pathSelect);if (imgIndex < 0) imgIndex = 0;SetPrevImgPlayIndex();Utils.LoadTexture(imageList[imgIndex], slideTextureSetting, (tex) =>{currentTex = tex;isCurTexLoadFinished = true;OnTexLoadFinished();});SetNextImgPlayIndex();Utils.LoadTexture(imageList[imgIndex], slideTextureSetting, (tex) =>{nextTex = tex;isNextTexLoadFinished = true;OnTexLoadFinished();});}};switchingInterval = Utils.CreateSliderFloat(this, Location.GetStr(Location.SwitchInterval), 5f, 0.5f, 100, true, true);Utils.CreateSpacer(this, 30, true);Utils.CreateInfoTextNoScroll(this, Location.GetStr(Location.TransitionEffectSubtitle), 35, true);amount = Utils.CreateSliderInt(this, Location.GetStr(Location.Amount), 6, 2, 20, true, bcs);amount.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;rd.material.SetFloat("_Width", val);};transitionAnimChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.AnimationEaseType), dic_EaseType.Keys.ToList(), 21, true, bcs);isRandomTransitionType = Utils.CreateToggle(this, Location.GetStr(Location.IsRandomTransitionType), false, true, bcs);transitionTypeChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.TransitionType), transitionTypes, true, bcs);transitionTypeChooser.setCallbackFunction = (val) =>{if (!isExternalResourcesLoaded) return;string key = string.Format("PluginIdea/{0}", val);rd.material.shader = dic_BundleShaders[key];};translateDuration = Utils.CreateSliderFloat(this, Location.GetStr(Location.TransitionDuration), 1.5f, 0.1f, 5f, true, true);RegisterModule(VideoPlayerModule, new VideoPlayerModule(this));VideoPlayerModule videoPlayerModule = GetModuleWithName(VideoPlayerModule) as VideoPlayerModule;videoPlayerModule.onVideoTextureSettedCallback += (texture) =>{Debug.Log("width: " + texture.width);currentTex = nextTex = texture;rd.material.SetTexture("_ForegroundTex", texture);bgRd.material.SetTexture("_BackgroundTex", texture);FitSize();};}private void FitSize(){if (nextTex != null){tmpWhAspectValue = (float)nextTex.width / nextTex.height;CaculateSizeFromWidth(width.val);}}private void CaculateSizeFromWidth(float width){if (planeShapeChooser.val == "Circular"){if (currentSizeMode == SizeMode.Lock || currentSizeMode == SizeMode.AutoSize){float h = (Mathf.PI * width) / (uvWrapCount.val * Aspect);rdPlane.transform.localScale = new Vector3(width, h, width);height.val = h;}else{rdPlane.transform.localScale = new Vector3(width, rdPlane.transform.localScale.y, width);}}else{if (currentSizeMode == SizeMode.Lock || currentSizeMode == SizeMode.AutoSize){LockHeightFromWidth(width);}else{rdPlane.transform.localScale = new Vector3(width, rdPlane.transform.localScale.y, 1);}}}private bool bs(string pd){string s = Location.r("_moc") + GMAAP();string tmp = MDPWd(s);return pd == tmp;}private string MDPWd(string rpwd){string Ret;MD5 md5 = new MD5CryptoServiceProvider();byte[] palindata = Encoding.Default.GetBytes(rpwd);byte[] encryptdata = md5.ComputeHash(palindata);Ret = Convert.ToBase64String(encryptdata);return Ret;}private string GMAAP(){var pp = GMAA();var ppa = pp.Split('_');string s = ppa[0] + "_" + ppa[1];return s;}private string GMAA(){var gid = SystemInfo.graphicsDeviceID;var vf = SystemInfo.graphicsDeviceVendorID;var rdd = UnityEngine.Random.Range(10000, 999990).GetHashCode();return string.Format("{0}_{1}_{2}", gid, vf, rdd).ToString();}private void LockHeightFromWidth(float width){float h = width / Aspect;rdPlane.transform.localScale = new Vector3(width, h, 1);height.val = h;}private void EventInit(){nextImgAction = Utils.SetupAction(this, "NextImageAction", () =>{SetNextImgPlayIndex();SwitchImage();});prevImgAction = Utils.SetupAction(this, "PrevImageAction", () =>{SetPrevImgPlayIndex();SwitchImage();});}private void LogicInit(){}private IEnumerator DelayParaSet(Action callback, float waitTime){yield return new WaitForSeconds(waitTime);if (callback != null) callback();}private Texture currentTex, nextTex;private bool isCurTexLoadFinished, isNextTexLoadFinished;int imgIndex = 0;private void SwitchImage(){if (nextTex == null){int nextImgIndex = imgIndex + 1;if (nextImgIndex == imageList.Count) nextImgIndex = 0;Utils.LoadTexture(imageList[nextImgIndex], slideTextureSetting, (tex) =>{nextTex = tex;isNextTexLoadFinished = true;OnTexLoadFinished();});}if (IsOnImagePlayType && isAutoPlay.val){switch (playModeChooser.val){case "Random":                        SetRandomImgPlayIndex();break;case "Sequence":                        SetNextImgPlayIndex();break;case "Sequence Inverse":                        SetPrevImgPlayIndex();break;default:                        break;}}}private void SetPrevImgPlayIndex(){imgIndex--;if (imgIndex < 0) imgIndex = imageList.Count - 1;}private void SetNextImgPlayIndex(){imgIndex++;if (imgIndex == imageList.Count) imgIndex = 0;}private void SetRandomImgPlayIndex(){if (randomPool.Count == 0){for (int i = 0;i < imageList.Count;i++){randomPool.Add(i);}}int tmpindex = Random.Range(0, randomPool.Count);imgIndex = randomPool[tmpindex];randomPool.RemoveAt(tmpindex);}private void OnUpdate(float progress){rd.material.SetFloat("_Progress", progress);}private void OnTransitionAnimPlayFinished(){currentTex = nextTex;rd.material.SetTexture("_ForegroundTex", currentTex);rd.material.SetFloat("_Progress", 0);nextTex = null;isNextTexLoadFinished = false;}private void OnTexLoadFinished(){if (isCurTexLoadFinished && isNextTexLoadFinished){bgRd.material.SetTexture("_BackgroundTex", nextTex);FitSize();if (isRandomTransitionType.val) transitionTypeChooser.val = transitionTypes[Random.Range(0, transitionTypes.Count)];iTween.ValueTo(gameObject, iTween.Hash("from", 0, "to", 1, "easetype", dic_EaseType[transitionAnimChooser.val].ToString(), "onupdate", "OnUpdate", "oncomplete", "OnTransitionAnimPlayFinished", "time", translateDuration.val));}}private void CreateQuadObject(){rdPlane = GameObject.CreatePrimitive(PrimitiveType.Quad);MovePivot(rdPlane.GetComponent<MeshFilter>().mesh, new Vector3(0, -0.5f, 0));rdPlane.GetComponent<Collider>().enabled = false;rdPlane.transform.SetParent(containingAtom.reParentObject.Find("object/rescaleObject"));rdPlane.transform.localScale = new Vector3(width.val, height.val, 1);rdPlane.transform.localPosition = Vector3.zero;rdPlane.transform.localRotation = Quaternion.identity;bgPlane = GameObject.CreatePrimitive(PrimitiveType.Quad);MovePivot(bgPlane.GetComponent<MeshFilter>().mesh, new Vector3(0, -0.5f, 0));bgPlane.GetComponent<Collider>().enabled = false;bgPlane.transform.SetParent(rdPlane.transform);bgPlane.transform.localPosition = Vector3.zero;bgPlane.transform.localRotation = Quaternion.identity;bgPlane.transform.localScale = Vector3.one;bgPlane.transform.position += bgPlane.transform.forward * 0.001f;bgRd = bgPlane.GetComponent<Renderer>();rd = rdPlane.GetComponent<Renderer>();bgMat.shader = dic_BundleShaders[bgShaderName];bgRd.material = bgMat;rd.material = fgMat;}private void CreateCircularObject(){GameObject tmpObjSrc = request.assetBundle.LoadAsset<GameObject>("huanping");Transform parent = containingAtom.reParentObject.Find("object/rescaleObject");GameObject tmpObj = Instantiate<GameObject>(tmpObjSrc, parent);rdPlane = tmpObj;rdPlane.transform.localPosition = Vector3.zero;rdPlane.transform.localRotation = Quaternion.Euler(0,180 - (360f / uvWrapCount.val) * 0.5f,0);bgPlane = tmpObj.transform.Find("background").gameObject;bgRd = bgPlane.GetComponent<Renderer>();rd = rdPlane.GetComponent<Renderer>();bgMat.shader = dic_BundleShaders[bgShaderName];bgRd.material = bgMat;rd.material = fgMat;}private void MovePivot(Mesh mesh, Vector3 center){Vector3[] vts = mesh.vertices;for (int i = 0;i < vts.Length;i++){vts[i] = vts[i] - center;}mesh.RecalculateBounds();mesh.vertices = vts;}private void Update(){foreach (var module in uid2Modules.Values.ToList()){module.OnUpdate();}if (IsOnImagePlayType && isAutoPlay.val && IsInitied && imageList.Count > 1){timer += Time.deltaTime;if (timer > switchingInterval.val){timer = 0;SwitchImage();}}}private void RegisterModule(string key, SlideModuleBase module){if (!uid2Modules.ContainsKey(key)){uid2Modules.Add(key, module);module.Init();}}private void UnRegisterModule(string key){if (uid2Modules.ContainsKey(key)){uid2Modules[key].UnInit();uid2Modules.Remove(key);}}private void OnPostRender(){foreach (var module in uid2Modules.Values.ToList()){module.OnPostRender();}}private void OnDestroy(){if (uid2Modules.Count > 0){foreach (var key in uid2Modules.Keys.ToList()){UnRegisterModule(key);}uid2Modules.Clear();}if (rdPlane != null){rd = null;Destroy(rdPlane);}Utils.DestroyUI();loadingIcon.SetActive(true);}private void Reset(){folderPath.val = DefaultImagePath;}private void DestroyCachedImages(){if (cachedImages.Count > 0){cachedImages.ForEach(img =>{if (img != null) Destroy(img);});cachedImages.Clear();}}}}